

/*-------------------------------------------------------------------------
    This source belongs to CAD vectorial fonts package Ver 3.0
       
    This file is the source code for the stand alone demo program
    Please feel free to copy the executable demo file, this source file and 
    the vectorial font files that comes with the demo package without
    modifications.
    
    readme.txt has information of interest
    
    Take a look at the comented lines at the end of the file
    
    Please read all the comments in the source code, specialy 
    the one in the PutDisplay() Function definition
    
---------------------------------------------------------------------------*/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "bios.h"
#include "conio.h"
#include "math.h"
#include "malloc.h"
#include "graph.h"

#include "..\include\fontlib.h"
#include "dos.h"



/* Demo global variables */
size_t FontFileLength;             
char *BufferFonts;                        


/*------------------------------------------------------------------------*/

/* These are the prototypes for functions that I use in the code, the are 
   in no way usefull for the Vectorial Font Package, only used in the demo 
 */  

void Introduction(void);
void PutDisplay(void);
void PutSetOfTextOnScreen(int From, int To);
void Message(char *string);
int  GetAnswer(void);
void PutDisplay(void);
void InitGraphics(void);
void InitTextMode(void);
void DrawPoint(int x, int y);
void Line(int x,int y,int x1,int y1);
void ByeBye(void);
int tg_getmaxy(void); 
int FontFileExists(char *FontFile);
size_t FontFileSize(char *FontFile);



/* Defining a seltest style for test only */
struct TextStyle Normal={ "Normal",          /* definition of Style */      
                          "classic4.fnt",    /* definition of the font file */      
                           0.0,              /* heigth         RESERVED */   
                           1.0,              /* with           RESERVED */   
                           0.0,              /* Obiquing angle RESERVED */   
                           FALSE,            /* BackWard       RESERVED */   
                           FALSE,            /* UpsideDown     RESERVED */   
                           HORIZONTAL};      /* initialized to HORIZONTAL */
                            

/* In the code of the program i will trace all the elements of the array 
   defined below, and display all the texts */

struct alltextdata{
                       char FontFile[15];                  /* font file name */
                       char String[255];                   /* string to output */
                       FONT_JUSTIFICATION  Justification;  /* type of justification */
                       int  x;                             /* first  X point */
                       int  y;                             /* first  Y point */
                       int  x1;                            /* second X point */
                       int  y1;                            /* second Y point */
                       double Heigth;                      /* font heigth */
                       double Angle;                       /* rotation angle */
                       BOOLEAN HorizontalOrVertical ; 
                       /* HORIZONTAL stands for horizontal,
                          VERTICAL   for vertical 
                        */
                           
                                                      
                       }AllTextData[]={
        /* from 0 to 6 */   
                        {"Classic4.fnt"    ,"Classic4 Sample 30"  ,DEFAULT,10  ,10  ,0  ,0 ,30 ,0 , HORIZONTAL },
                        {"letter2.fnt"     ,"Letter2 sample 30"     ,DEFAULT,10  ,60  ,0  ,0 ,30 ,0 , HORIZONTAL },
                        {"current3.fnt"    ,"Current3 Sample 30"  ,DEFAULT,10  ,110 ,0  ,0 ,30 ,0 , HORIZONTAL },
                        
                        /* now Heigth=15 */
                        
                        {"Classic4.fnt"    ,"Classic4 Sample 15"  ,DEFAULT,200  ,160 ,0  ,0 ,15 ,0 , HORIZONTAL },
                        {"letter2.fnt"     ,"Letter2 sample 15"     ,DEFAULT,200  ,190 ,0  ,0 ,15 ,0 , HORIZONTAL },
                        {"current3.fnt"    ,"Current3 Sample 15"  ,DEFAULT,200  ,220 ,0  ,0 ,15 ,0 , HORIZONTAL },
       /* from 6 to 9 */                    
                        /* now Heigth=10 */                
                        
                        {"Classic4.fnt"    ,"Classic4 Sample 10"  ,DEFAULT,250  ,250 ,0  ,0 ,10 ,0 , HORIZONTAL },
                        {"letter2.fnt"     ,"Letter2 sample 10"     ,DEFAULT,250  ,270 ,0  ,0 ,10 ,0 , HORIZONTAL },
                        {"current3.fnt"    ,"Current3 Sample 10"  ,DEFAULT,250  ,290 ,0  ,0 ,10 ,0 , HORIZONTAL },
       /* from 9 to 10 */                    
                        /* now Heigth=120 */                
                        
                        {"Classic4.fnt"     ,"Big"                ,DEFAULT,10 ,100 ,0  ,0 ,200,0 , HORIZONTAL },
       /* from 10 to 14 */                    
                        /* other options 11 to 14 */
                        
                        {"Classic4.fnt"     ,"Numbers can also be displayed"  ,DEFAULT,40  ,130 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"     ,"1234567890"                     ,DEFAULT,40  ,100 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"     ,"as well as other characters"    ,DEFAULT,40  ,70  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"     ,"!@#$%^&*()_+=-/?']}[{~"         ,DEFAULT,40  ,40  ,0  ,0 ,20 ,0 , HORIZONTAL },
       /* from 14 to 18 */                    
                        /* other options 14 to 18 */
                        
                        {"current3.fnt"     ,"Numbers can also be displayed"  ,DEFAULT,40  ,130 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"     ,"1234567890"                     ,DEFAULT,40  ,100 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"     ,"as well as other characters"    ,DEFAULT,40  ,70  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"     ,"!@#$%^&*()_+=-/?']}[{~"         ,DEFAULT,40  ,40  ,0  ,0 ,20 ,0 , HORIZONTAL },
       /* from 18 to 22 */                    
                        /* other options (totation) 18 to 22 */
                        
                        {"Classic4.fnt"    ,"Classic4 Rotated"  ,DEFAULT,100  ,130 ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"current3.fnt"    ,"Current3 Rotated" ,DEFAULT,100  ,90  ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"letter2.fnt"     ,"Letter2 Rotated"     ,DEFAULT,100  ,50  ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"Classic4.fnt"    ,"Classic4 Rotated"  ,DEFAULT,100  ,10  ,0  ,0 ,20 ,45 , HORIZONTAL },
       /* from 22 to 30 */                    
                        /* other options (other totation) 22 to 31 */
                        
                        {"Classic4.fnt"     ,"  0=360 degrees" ,DEFAULT,320  ,200  ,0  ,0 ,15 ,0   , HORIZONTAL },
                        {"Classic4.fnt"     ,"  45   degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,45  , HORIZONTAL },
                        {"Classic4.fnt"     ,"  90   degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,90  , HORIZONTAL },
                        {"Classic4.fnt"     ,"  135  degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,135 , HORIZONTAL },
                        {"Classic4.fnt"     ,"  180  degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,180 , HORIZONTAL },
                        {"Classic4.fnt"     ,"  225  degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,225 , HORIZONTAL },
                        {"Classic4.fnt"     ,"  270  degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,270 , HORIZONTAL },
                        {"Classic4.fnt"     ,"  315  degrees"  ,DEFAULT,320  ,200  ,0  ,0 ,15 ,315 , HORIZONTAL },
       /* from 30 to 33 */                    
                        /* Centered fonts 31 to 35 */
                        
                        {"Classic4.fnt"   ," Centered Classic4 font"    ,CENTERED,320  ,100 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ," Centered Classic4 font"    ,CENTERED,320  ,70  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ," Centered Classic4 font"    ,CENTERED,320  ,40  ,0  ,0 ,20 ,0 , HORIZONTAL },
       /* from 33 to 36 */                    
                        
                        {"current3.fnt"   ,"Centered Current3 font"    ,CENTERED,320  ,100 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"   ,"Centered Current3 font"    ,CENTERED,320  ,70  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"   ,"Centered Current3 font"    ,CENTERED,320  ,40  ,0  ,0 ,20 ,0 , HORIZONTAL },
       
       /* from 36 to 39 */                                     
                        {"current3.fnt"   ,"Centered rotated"    ,CENTERED,320  ,100 ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"current3.fnt"   ,"Centered rotated"    ,CENTERED,320  ,70  ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"current3.fnt"   ,"Centered rotated"    ,CENTERED,320  ,40  ,0  ,0 ,20 ,45 , HORIZONTAL },
       
       /* from 39 to 42 */                           
                        /* Rigth justified */          
                                                
                        {"current3.fnt"   ,"Rigth Justified font" ,RIGHT,630  ,100 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"   ,"Rigth Justified font" ,RIGHT,630  ,70  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"current3.fnt"   ,"Rigth Justified font" ,RIGHT,630  ,40  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        
       /* from 42 to 45 */                           
                        /* Rigth justified */          
                                                
                        {"Classic4.fnt"   ,"Right + Rotated" ,RIGHT,630  ,120 ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Right + Rotated" ,RIGHT,630  ,80  ,0  ,0 ,20 ,45 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Right + Rotated" ,RIGHT,630  ,40  ,0  ,0 ,20 ,45 , HORIZONTAL },
       
       /* from 45 to 52 */                                                   
                        {"Classic4.fnt"   ,"=========================" ,DEFAULT,30  ,230 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"`1234567890-=+_)(*&^%$#@!" ,DEFAULT,30  ,200 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"   qwertyuiopPOIUYTREWQ"   ,DEFAULT,30  ,170 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"    asdfghjklLKJHGFDSA"    ,DEFAULT,30  ,140 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"      zxcvbnmMNBVCXZ"      ,DEFAULT,30  ,110 ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"    {}[]:;'<>?/.,\\|~`"    ,DEFAULT,30  ,80  ,0  ,0 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"=========================" ,DEFAULT,30  ,50  ,0  ,0 ,20 ,0 , HORIZONTAL },
       
       /* from 52 to 59 */                                                                    
                        /* Fitted text needs the two points specification */
                        
                        {"Classic4.fnt"   ,"Fitted"                                                            ,FIT,30  ,230 ,600  ,230 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Fitted Text"                                                       ,FIT,30  ,200 ,600  ,200 ,20 ,0 , HORIZONTAL },                       
                        {"Classic4.fnt"   ,"This is a Fitted Text between two points (30,170) and (600,170)"   ,FIT,30  ,170 ,600  ,170 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"1234567890"                                                        ,FIT,30  ,140 ,600  ,140 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Long"                                                              ,FIT,30  ,110 ,600  ,110 ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"The quick brown fox jumps over the lazy dog with fitted texts"     ,FIT,30  ,80  ,600  ,80  ,20 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Nice"                                                              ,FIT,30  ,50  ,600  ,50  ,20 ,0 , HORIZONTAL },
       
       /* from 59 to 61 */                                                                                     
                        {"Classic4.fnt"   ,"Bigger and fitted" ,FIT,30  ,200 ,400  ,200 ,100 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Nice"              ,FIT,30  ,10  ,400  ,10  ,100 ,0 , HORIZONTAL },                       
       
       /* from 61 to 63 */                                                                                     
                        {"Classic4.fnt"   ,"Bigger and fitted" ,FIT,30  ,200 ,150  ,200 ,100 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Nice"              ,FIT,30  ,10  ,300  ,10  ,100 ,0 , HORIZONTAL },                       
       
       /* from 63 to 65 */                                                                                     
                        {"Classic4.fnt"   ,"Bigger and fitted" ,FIT,30  ,200 ,50   ,200 ,100 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Nice"              ,FIT,30  ,10  ,100  ,10  ,100 ,0 , HORIZONTAL },                       
       
       /* from 65 to 67 */                                                                                     
                        {"Classic4.fnt"   ,"Bigger and fitted" ,FIT,30  ,200 ,35   ,200 ,140 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Nice"              ,FIT,30  ,10  ,40   ,10  ,140 ,0 , HORIZONTAL },                       
       
       /* from 67 to 74 */                                                                    
                        
                        {"Classic4.fnt"   ,"Fitted & rotated"                                                          ,FIT,30  ,230 ,600  ,350 ,10 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Fitted Text & rotated"                                                     ,FIT,30  ,200 ,600  ,320 ,10 ,0 , HORIZONTAL },                       
                        {"Classic4.fnt"   ,"This is a Fitted Text between two points (30,170) and (600,290) & rotated" ,FIT,30  ,170 ,600  ,290 ,10 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"1234567890 & rotated"                                                      ,FIT,30  ,140 ,600  ,260 ,10 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Long & rotated"                                                            ,FIT,30  ,110 ,600  ,230 ,10 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"The quick brown fox jumps over the lazy dog with fitted texts & rotated"   ,FIT,30  ,80  ,600  ,200 ,10 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"Nice & rotated"                                                            ,FIT,30  ,50  ,600  ,170 ,10 ,0 , HORIZONTAL },
       
       /* from 74 to 76 */                                                                                     
                        {"Classic4.fnt"   ,"You are upside Down" ,FIT,400  ,200 ,30  ,200 ,100 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"or is it me ?"       ,FIT,400  ,100 ,30  ,100 ,100 ,0 , HORIZONTAL },
       
       /* from 76 to 78 */                                                                                     
                        {"Classic4.fnt"   ,"You are upside Down" ,FIT,200  ,300 ,30  ,300 ,100 ,0 , HORIZONTAL },
                        {"Classic4.fnt"   ,"or is it me ?"       ,FIT,100  ,200 ,30  ,200 ,100 ,0 , HORIZONTAL },
       
       /* from 79 to 84 */                                                                                     
                        {"Classic4.fnt"   ,"Vectorial fonts"      ,DEFAULT,50   ,300 ,0  ,0   ,10   ,0 , VERTICAL   },
                        {"Classic4.fnt"   ,"can be output"        ,DEFAULT,100  ,300 ,0  ,0   ,10   ,0 , VERTICAL   },
                        {"Classic4.fnt"   ,"in a vertical"        ,DEFAULT,150  ,300 ,0  ,0   ,10   ,0 , VERTICAL   },
                        {"Classic4.fnt"   ,"position"             ,DEFAULT,200  ,300 ,0  ,0   ,10   ,0 , VERTICAL   },
                        {"Classic4.fnt"   ,"1234567890"           ,DEFAULT,250  ,300 ,0  ,0   ,10   ,0 , VERTICAL   },
                        {"Classic4.fnt"   ,"`@#$%^&*()_+=_!~><:;" ,DEFAULT,300  ,300 ,0  ,0   ,10   ,0 , VERTICAL   },


       
       /* from 84 to 92 */  
                        {"Classic4.fnt"     ,"  0=360 degrees" ,DEFAULT,320  ,240  ,0  ,0 ,10 ,0   , VERTICAL },
                        {"Classic4.fnt"     ,"  45 degrees"    ,DEFAULT,320  ,240  ,0  ,0 ,10 ,45  , VERTICAL },
                        {"Classic4.fnt"     ,"  90 degrees"    ,DEFAULT,320  ,240  ,0  ,0 ,10 ,90  , VERTICAL },
                        {"Classic4.fnt"     ,"  135 degrees"   ,DEFAULT,320  ,240  ,0  ,0 ,10 ,135 , VERTICAL },
                        {"Classic4.fnt"     ,"  180 degrees"   ,DEFAULT,320  ,240  ,0  ,0 ,10 ,180 , VERTICAL },
                        {"Classic4.fnt"     ,"  225 degrees"   ,DEFAULT,320  ,240  ,0  ,0 ,10 ,225 , VERTICAL },
                        {"Classic4.fnt"     ,"  270 degrees"   ,DEFAULT,320  ,240  ,0  ,0 ,10 ,270 , VERTICAL },
                        {"Classic4.fnt"     ,"  315 degrees"   ,DEFAULT,320  ,240  ,0  ,0 ,10 ,315 , VERTICAL },
                                                
                        };     

#define MAX_NUM_PRIMITIVES_FILE 2000
struct primitivefile Display[MAX_NUM_PRIMITIVES_FILE];

TEXTOUPUTSTATE  OuttextState;  /* structure returned by Text() function */
#define DisplayIndex (OuttextState.LastPrimitiveIndex)
     
/*------------------------------------------------------------------------*/
void main(void);
void main(void)
{
   int i=0;
   int CurrentCase=1; /* =1 */
   int Answer=0;

   Introduction(); /* not usefull */
   

    /* loading default font file */
    
    if(FontFileExists(Normal.FontFile))               /* see if its on disk */       
      FontFileLength=FontFileSize(Normal.FontFile);   /* get the size */
    else
      {
       cputs("font file classic4.fnt does not exist\r\n");
       exit(0);  
      }
  
    /* get some memory for the buffer that will hold the font file */
    if((BufferFonts=( char *) calloc(sizeof( char),(size_t)FontFileLength))==NULL)
      {
      cputs("NO Memory in text for bufferfonts \r\r\n");
      exit(0);
      }
     
      
   /* Initializing the font file, this function loads the font file,
      builds a internal table with each font, so execution is faster */
      
   
    UserSetPF(Display , MAX_NUM_PRIMITIVES_FILE);   
   
   {
   int Value=OK;
   if((Value=InitStyle(Normal,BufferFonts,FontFileLength))!=OK)
     {   
     cputs("\r\nImpossible to Open Font File or Not Enough Memory");
     exit(1);
     }      
   }           
     
     InitGraphics(); /* graphic initialization */
     
     
     
  do{ 
     
     switch(CurrentCase)
           {
      
             case  1:
                     PutSetOfTextOnScreen(0,6);
                     Message("As shown below,fonts can be displayed in different sizes");
                     Message("The text is left Justified (LEFT JUSTIFIED)");
                              
                     Answer=GetAnswer();
                     if(Answer==27)  /* 27 is the code for ESC key */
                       CurrentCase=70;
                     else
                       if(Answer==1)
                         CurrentCase+=Answer;  
                            
                     break;
     
             case 2:
                     PutSetOfTextOnScreen(6,9);
                     Message("Heigth is now 10 mm only (SIZE)");
                              
                     Answer=GetAnswer();
                     if(Answer==27)  /* 27 is the code for ESC key */
                       CurrentCase=70;
                     else
                        CurrentCase+=Answer;  
                         
                     break;
                 
             case 3:
                    PutSetOfTextOnScreen(9,10);
                    Message("A big text 200mm (SIZE)");
                          
                    Answer=GetAnswer();
                    if(Answer==27)  /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                       CurrentCase+=Answer;  
                    break;
                     
             case 4:
                    PutSetOfTextOnScreen(10,14);
                    Message("No comment");
                      
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                 
             case 5:
                    PutSetOfTextOnScreen(14,18);
                    Message("Of course, you can change to a Current3 font");
                          
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 6:
                    PutSetOfTextOnScreen(18,22);
                    Message("So far so good");
                    Message("Vectorial fonts can also be rotated from 0 to 359 degrees (ROTATION)");
                     
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 7:
                    PutSetOfTextOnScreen(22,30);
                                              
                                              
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 8:     
                    PutSetOfTextOnScreen(30,33);
                    Message("Centered fonts (CENTERED)");
                          
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 9:
                    PutSetOfTextOnScreen(33,36);
                    Message("Centered fonts (Current3)");
                          
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 10:
                    PutSetOfTextOnScreen(36,39);
                    Message("We can rotate a centered font too (CENTERED+ROTATION)");
                    Message("Centered rotated fonts (Current3)");
                          
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
                     
             case 11:
                    PutSetOfTextOnScreen(39,42);
                    Message("RIGHT Justified font");
                    Message("Centered rotated fonts (Current3)");
                          
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 12:
                    PutSetOfTextOnScreen(42,45);
                    Message("Rigth Justified and rotated font (RIGTH JUSTIFIED+ROTATION)");
                          
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else
                      CurrentCase+=Answer;  
                    break;
                     
             case 13:
                    PutSetOfTextOnScreen(45,52);
                    Message("All character set");
                     
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    break;
                           
             case 14:
                    PutSetOfTextOnScreen(52,59);
                    Message("Fitted Text (FITTED)");
                                      
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    break;  
                                 
             case 15:
                    PutSetOfTextOnScreen(59,61);
                    Message("Big fitted text");
                              
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    break;     
             case 16:
                    PutSetOfTextOnScreen(61,63);
                    Message("A more compressed fitted Text (FITTED)");
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    break;  
                            
                    
             case 17:
                    PutSetOfTextOnScreen(63,65);
                    Message("A more compressed fitted Text (FITTED)");
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    break;  
                    
             
             case 18:
                    PutSetOfTextOnScreen(65,67);
                    Message("Wow! I cant read this anymore (FITTED)");
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    
                    
                    break;       
             case 19:
                    PutSetOfTextOnScreen(67,74);
                    Message("Fitted Text (FITTED)");                   
                    
                    Message("Changing the Y coord of the last point afects the rotation");
					Message("Fitted text are not rotated changing the angle but the");
                    Message("final x,y point");
                    
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    
                    break;  
             case 20:
                    PutSetOfTextOnScreen(74,76);
                    Message("Upside down fitted text are alowed (FITTED)");
                    Message("Changing first point coords with the last coords");
                    Message("can make this effect");
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer;  
                    
                    break;  
             case 21:
                    PutSetOfTextOnScreen(76,78);
                    Message("Streched upside down text (FITTED)");                   
                    
                    
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer; 
                    break;   
             
       
             case 22:
                    PutSetOfTextOnScreen(78,84);
                    Message("Vertical text can be output also (VERTICAL)");
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else                     
                      CurrentCase+=Answer; 
                    
                    break;       
      
             case 23:
                    PutSetOfTextOnScreen(84,92);
                    Message("Lets try something interesting (VERTICAL+ROTATION)");                   
                    
                    /*---------------------*/
                    Answer=GetAnswer();
                    if(Answer==27) /* 27 is the code for ESC key */
                      CurrentCase=70;
                    else          
                    if(Answer==-1)          
                      CurrentCase+=Answer;  
                    else
                      CurrentCase=70;  
                    /*--------------------*/                  
                    break;   
       
             
     }
   }while(CurrentCase!=70);  
     
               
   InitTextMode();               /* go back to text mode */
   free((void*)BufferFonts);   
     
   ByeBye();                     
   getch();
     /* bye */
}
/*-----------------------------------------------------------------------*/
/* 

The PutDisplay() function is a user defined function, at the output of
the text() function the Display table (type PrimitiveFile) is filled with 
the ending points of each vector needed to draw the text.OpCode flag
specifies if this vector is to be MOVED or to be DRAWN with the PFMOVETO and
PFMOVETO definitions.

DisplayIndex has the Maximum value to trace in the Display Table

for example a letter can generated the following table
 
OpCode=PFMOVETO x=0       y=0     move to the 0,0 point
OpCode=PFLINETO x=249     y=312   trace a Line to the (249,312) point
OpCode=PFLINETO x=624     y=249   ...and so on
OpCode=PFLINETO x=249     y=312        .
OpCode=PFMOVETO x=249     y=312        .
OpCode=PFMOVETO x=336     y=280        .
OpCode=PFLINETO x=218     y=218        .
OpCode=PFLINETO x=187     y=236        .
OpCode=PFLINETO x=187     y=236
               ....
               
Note that the actual drawing action is defined by the user, if you use a pair
of _moveto and _lineto function, as this function does,you will draw the text
in the display, but you could also implement a DXF file format, That can be
generated following the same idea as is shown further in this demo example,
or perhaps a plotter file format.

for example:
            
The PutDisplay() could be defined like this:            

 -> simbol at the left indicate the changes                                                               
                                                               
----------------------------------------------------------------------------
void PutDisplay(void)
{
   register i;
   int y=tg_getmaxy();
      
   for(i=0;i<DisplayIndex;i++)   
      {
       if(Display[i].OpCode==PFMOVETO)  
->       DxfMoveto((short)Display[i].x,y-(short)Display[i].y); 
       else    
          {
->        DxfLine((short)Display[i].x,y-(short)Display[i].y); 
          }
      }
}                    

-----------------------------------------------------------------------------
DxfMoveto() and DxfLine() are user defined functions where dxf format lines 
are generated to a file.

similar definition of the functions body can be made if we wanted to make a
plotter HPGL language file.


The PutDisplay() function must be called after the Text() function is called
because the Display array will hold the information only until the next Text() 
function is invoked, of course you can always save the information in a 
linked list so it isn't lost.

As defined at the top of this source code:
extern struct PrimitiveFile Display[MAX_NUM_PRIMITIVES_FILE];

Display array of type PrimitiveFile has only MAX_NUM_PRIMITIVES_FILE
elements, so the all the vectors of text needed to be output must NOT
be greater than MAX_NUM_PRIMITIVES_FILE (defined in fonts.h as 3000)

The number of vector needed for a letter differs from one style to another,
for example: the character A in a GOTHIC style needs more vectors than an A
in a TXT style, so you must be careful not to over pass the maximum number
of vectors alowed.

It is very dificult to determine for each style how many vectors are needed 
to draw a text because the number of vectors also vary between the different
characters within the style selected.

Source code of the Vectorial font library is also available, with the 
source code you can change the number of vectors needed, please read 
the readme.txt file that comes with this package

The y=tg_getmaxy(); definition within the body of the PutDisplay()
function is needed to invert the coords in the Y axis, The graphic 
functions of Microsoft(c) are implemented with the 0,0 coord in the
upper left corner, our functions work with the 0,0 in the lower left
corner, so the Y coords of the _moveto() and _lineto() are changed
with the 'y-' before the Display[i].y coord

         
         
                                       |
                                       V
         _moveto((short)Display[i].x , y-(short)Display[i].y ); 
         
                                       |
                                       V         
         _lineto((short)Display[i].x , y-(short)Display[i].y);  
         
         

*/

#define WHITE 15


void PutDisplay(void);
void PutDisplay(void)
{
   unsigned long i=0;
   int y=tg_getmaxy();
    
   /* Trace from the first element in the table (0) to the last one (defined)
      in the variable LastPrimitiveIndex returned by Text(), LastPrimitiveIndex 
      is updated wen the Text() function is called 
    */  
      for(i=0;i<DisplayIndex;i++)   
      {
       if(Display[i].OpCode==PFMOVETO)   
         /* move to the position */
         _moveto((short)Display[i].x,y-(short)Display[i].y);  /* y- stands for invertin axes */
       else                              /* Display[i].OpCode==PFLINETO */
          {
           _setcolor(WHITE);             
           /* draw to the position */
           _lineto((short)Display[i].x,y-(short)Display[i].y);  /* y- stands for invertin axes */
          }
      }
}                    
/*-----------------------------------------------------------------------*/
#define STARTPOINT 3

void DrawPoint(int x, int y);
void DrawPoint(int x, int y)
{    
int VideoY=tg_getmaxy();

_setcolor(STARTPOINT);             

Line(x,VideoY-y,x+10,VideoY-y+10);
Line(x,VideoY-y,x-10,VideoY-y-10);
Line(x,VideoY-y,x+10,VideoY-y-10);
Line(x,VideoY-y,x-10,VideoY-y+10);

}
/*----------------------------------------------------------------*/
void Line(int x,int y,int x1,int y1); /* draw a line between two points */
void Line(int x,int y,int x1,int y1)
{
_moveto((short)x,(short)y);
_lineto((short)x1,(short)y1);
}
/*-----------------------------------------------------------------*/
void InitTextMode(void);  /* go back to text mode */
void InitTextMode(void)
{
  _setvideomode(_DEFAULTMODE);
}
/*---------------------------------------------------------------------*/
/* Returns the max number of pixels in y cood */
int tg_getmaxy(void); 
int tg_getmaxy(void)
{                
struct videoconfig config;

  _getvideoconfig(&config);
   return(config.numypixels);
}

/*---------------------------------------------------------------------*/
void InitGraphics(void); /* begin graphic mode */
void InitGraphics(void)
{                
  _settextcolor(7);
  _settextposition(1,1);
  _clearscreen(_GCLEARSCREEN);
    
  if (_setvideomode(_VRES16COLOR))
   return;
  if (_setvideomode(_ERESCOLOR))
   return;
  
  cputs("This demo program  only runs in VGA or EGA Display\r\n");
  exit(0);
}
/*----------------------------------------------------------------------*/
void Introduction(void);   /* introoduction text */
void Introduction(void)
{
int Com;

cputs("Vectorial Font Demo #2\r\n\r\n");

cputs("Vectorial text can be output as folows:\r\n\r\n");

cputs("  Left Justified (default justification)\r\n");
cputs("  Rigth Justified\r\n");
cputs("  Centered text\r\n");
cputs("  Fitted between two points\r\n\r\n");

cputs("They can also be rotated from 0 to 359 degrees\r\n");
cputs("be sized with values of heigth bigger than 0\r\n");
cputs("and set to Horizontal or Vertical positions\r\n\r\n");

cputs("Vectorial text data can be output to the display, plotter, or whatever\r\n");
cputs("this is posible because a table is build with all the points of the vectors \r\n");
cputs("to make the shape of the font in use, and you are responsable to make the\r\n");
cputs("output function\r\n\r\n");

cputs("This program can be copied freely as long as no modifications are made to it\r\n");
     
cputs("\r\nHit any key to continue...(Esc ends execution)\r\n ");


Com=getch();
if(Com==27)  /* 27 is the code for ESC key */
  exit(1);                                               
}   
/*------------------------------------------------------------------*/
void ByeBye(void); /* bye baby bye bye */
void ByeBye(void)
{
cputs("Vectorial Font files and library is the right thing for you\r\n");
cputs("and your software, so make up your mind and fill up the form\r\n");
cputs("TODAY !, orderme.txt has all you need\r\n");
}

/*-----------------------------------------------------------------*/
void PutSetOfTextOnScreen(int From, int To);
void PutSetOfTextOnScreen(int From, int To)
{
int i=0;
RW_POINT Pt1;
RW_POINT Pt2;


_clearscreen(_GCLEARSCREEN);
  
     for(i=From;i<To;++i)
        {              
                
        /* if the new font to be used is not the same as the last one used or the orientation changes */
        if((strcmp(Normal.FontFile,AllTextData[i].FontFile)!=0) || Normal.Orient!=AllTextData[i].HorizontalOrVertical) 
          {
          /* free previous font loaded at the beginning of the program */
          Normal.Orient=AllTextData[i].HorizontalOrVertical;
          
          free((void*)BufferFonts);     
          

          /* loading the new font file */
          if(FontFileExists(AllTextData[i].FontFile))
            FontFileLength=FontFileSize(AllTextData[i].FontFile);
          else
            exit(0);  
     
          
         /* get some memory for the buffer */
         if((BufferFonts=( char *) calloc(sizeof( char),(size_t)FontFileLength))==NULL)
            {
            cputs("NO Memory in text for bufferfonts \r\r\n");
            exit(0);
            }
         
         /* update the new style to use */
         strcpy(Normal.FontFile,AllTextData[i].FontFile); /* update */
            
         /* Initializing the font file, this function loads the font file,
            builds a internal table with each font, so execution is faster */
         if(InitStyle(Normal,BufferFonts,FontFileLength)!=OK)
           {   
           cputs("\r\nImpossible to Open Font File or Not Enough Memory");
           exit(1);
           }               
         }
                   
         
        /* Updating the Pt1 and Pt2 structures */
        
        Pt1.x=AllTextData[i].x ;
        Pt1.y=AllTextData[i].y ;
        Pt2.x=AllTextData[i].x1;
        Pt2.y=AllTextData[i].y1;
        
        
        /* draw an X at the starting point of the text */
        DrawPoint(AllTextData[i].x , AllTextData[i].y);
        
        
        if(AllTextData[i].x1!=0 && AllTextData[i].y1!=0)
          DrawPoint(AllTextData[i].x1 , AllTextData[i].y1);
                
        
        /* Calling the Text() function builds up a table with moveto and
           lineto codes associated with the corresponding x,y values
           */
        
        OuttextState=Text(
             AllTextData[i].String,          /* string to output */
             AllTextData[i].Justification,   /* the justification is in the header */
             Pt1,                            /* first point */
             Pt2,                            /* second point */
             AllTextData[i].Heigth,          /* Heigth of the font */
             AllTextData[i].Angle*(3.1415/180.0), /* Angle to rotate (Radians)*/
             BufferFonts );                  /* The Buffer where the font is loaded */
     
        PutDisplay(); /* Output to display, this is a user defined function */
        }
}
/*-----------------------------------------------------------------------*/

void Message(char *string);
void Message(char *string)
{
cputs(string);
cputs("\r\n");

}
/*-------------------------------------------------------------------------*/
int GetAnswer(void);
int GetAnswer(void)
{               

int Answer;           
Message("(F)oward (return) , (B)ack ,(Esc) ends");
Answer=getch();

if(Answer=='f' || Answer=='F' || Answer==13)
   return(1);
if(Answer=='b' || Answer=='B')
   return(-1);
if(Answer==27)  /* 27 is the code for ESC key */
   return(27);   

/* else  */
   return(1);
}   
/*------------------------------------------------------------------------*/
int FontFileExists(char *FontFile);
int FontFileExists(char *FontFile)
{
struct find_t Buffer;
return(!_dos_findfirst(FontFile,_A_NORMAL,&Buffer));
}

/*-------------------------------------------------------*/
size_t FontFileSize(char *FontFile);
size_t FontFileSize(char *FontFile)
{
struct find_t Buffer;
_dos_findfirst(FontFile,_A_NORMAL,&Buffer);
return((size_t)Buffer.size);
}
/*------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------*/

/*


 Comments about the demo program
 
  
   1- Every time we load a different style we reserve memory with calloc() 
      and then free it up with the free() function (in the example we use 
      BufferFont as the buffer tha holds the style information), 
      this is not necesary if you reserve a sizeof() the biggest font you
      are going to use in your application,and each time you need another 
      style simply pass the BufferFonts to the InitStyle(Normal,BufferFonts,
      FontFileLength) function, this avoids fragmented memory
      caused by calling calloc() and free() several times.
      
   2- DrawPoint(),PutDisplay() functions slows down the execution of the 
      program because of the use of the tg_getmaxy() function.
   
   3- Every time we change he font we must load it from disk, this slows 
      down the execution too.  
      

*/

