





#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "graph.h"
#include "dos.h"

#include "..\include\fontlib.h"

struct TextStyle Normal={ "Normal",          /* definition of Style */      
                          "classic4.fnt",     /* definition of the font file */      
                           0.0,              /* heigth         RESERVED */   
                           1.0,              /* with           RESERVED */   
                           0.0,              /* Obiquing angle RESERVED */   
                           FALSE,            /* BackWard       RESERVED */   
                           FALSE,            /* UpsideDown     RESERVED */   
                           HORIZONTAL};      /* initialized to HORIZONTAL */


void InitTextMode(void); 
int  tg_getmaxy(void); 
void InitGraphics(void); 
void PutDisplay(void);
int FontFileExists(char *FontFile);
size_t FontFileSize(char *FontFile);



#define MAX_NUM_PRIMITIVES_FILE 2000
struct primitivefile Display[MAX_NUM_PRIMITIVES_FILE];

TEXTOUPUTSTATE  OuttextState;  /* structure returned by Text() function */
#define DisplayIndex (OuttextState.LastPrimitiveIndex)

char * BufferFonts;

/*--------------------------------------------------------------------------*/
void main(void);
void main(void)
{ 
size_t FontFileLength;
FILE *fp;

/* loading default font file */
    
if(FontFileExists(Normal.FontFile))               /* see if its on disk */       
  FontFileLength=FontFileSize(Normal.FontFile);   /* get the size */
else
  {
  cputs("font file classic4.fnt does not exist\r\n");
  exit(0);  
  }
      
/* get some memory for the buffer that will hold the font file */
if((BufferFonts=( char *) calloc(sizeof( char),(size_t)FontFileLength))==NULL)
  {
  cputs("NO Memory in text for bufferfonts \r\r\n");
  exit(0);
  }
     
      
/* Initializing the font file, this function loads the font file,
  builds a internal table with each font, so execution is faster */
      
   
UserSetPF(Display , MAX_NUM_PRIMITIVES_FILE);   
   
if(InitStyle(Normal,BufferFonts,FontFileLength)!=OK)
 {   
 cputs("\r\nImpossible to Open Font File or Not Enough Memory");
 exit(1);
 }               
     
 InitGraphics(); /* graphic initialization */
 
 
 if((fp=fopen("loadtext.txt","r"))!=NULL)
    {
    char Buffer[255];
    int XPos=10;
    double Heigth=10.0;
    double Angle=0.0;
    RW_POINT Pt1;
    RW_POINT Pt2;

    
    Pt1.x=XPos;
    Pt1.y=300;
    
    while(!feof(fp)) /* while end of file not reached */
         {
         
         if((fgets(Buffer,255,fp))!=NULL)
           {
           /* Buffer has a \n at the end */
           OuttextState=Text(
             Buffer,               /* string to output */
             DEFAULT,              /* the justification is in the header */
             Pt1,                  /* first point */
             Pt2,                  /* second point */
             Heigth,               /* Heigth of the font */
             Angle*(3.1415/180.0), /* Angle to rotate (Radians)*/
             BufferFonts );        /* The Buffer where the font is loaded */
          
           PutDisplay(); /* display the string */
           
           /* after the string has been displayed the \n works as a line feed
              at the end makes the Y position point to the next line, but
              the x value must be set again to the initial x value
              */
           
          
           /* Pt1.x does not change, it keeps the initial value */
           Pt1.y=OuttextState.LastPt.y;
           }
         }  
    }
    else
        cputs("Cant open loadtext.txt from disk\r\n");
        
fclose(fp);        
getch();   
        
        
}                        
#define WHITE 15
/*-----------------------------------------------------------------------*/
void PutDisplay(void);
void PutDisplay(void)
{
   unsigned long i=0;
   int y=tg_getmaxy();
    
   /* Trace from the first element in the table (0) to the last one (defined)
      in the variable LastPrimitiveIndex returned by Text(), LastPrimitiveIndex 
      is updated wen the Text() function is called 
    */  
   for(i=0;i<DisplayIndex;i++)   
      {
       if(Display[i].OpCode==PFMOVETO)   
         /* move to the position */
         _moveto((short)Display[i].x,y-(short)Display[i].y);  /* y- stands for invertin axes */
       else                              /* Display[i].OpCode==PFLINETO */
          {
           _setcolor(WHITE);             
           /* draw to the position */
           _lineto((short)Display[i].x,y-(short)Display[i].y);  /* y- stands for invertin axes */
          }
      }
}                    
/*---------------------------------------------------------------------*/
void InitTextMode(void);  /* go back to text mode */
void InitTextMode(void)
{
  _setvideomode(_DEFAULTMODE);
}
/*---------------------------------------------------------------------*/
/* Returns the max number of pixels in y cood */
int tg_getmaxy(void); 
int tg_getmaxy(void)
{                
struct videoconfig config;

  _getvideoconfig(&config);
   return(config.numypixels);
}

/*---------------------------------------------------------------------*/
void InitGraphics(void); /* begin graphic mode */
void InitGraphics(void)
{                
  _settextcolor(7);
  _settextposition(1,1);
  _clearscreen(_GCLEARSCREEN);
  /*  
  if (_setvideomode(_VRES16COLOR))
   return;
  */ 
   
  if (_setvideomode(_ERESCOLOR))
   return;
  
  cputs("This demo program  only runs in VGA or EGA Display\r\n");
  exit(0);
}
/*---------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
int FontFileExists(char *FontFile);
int FontFileExists(char *FontFile)
{
struct find_t Buffer;
return(!_dos_findfirst(FontFile,_A_NORMAL,&Buffer));
}

/*-------------------------------------------------------*/
size_t FontFileSize(char *FontFile);
size_t FontFileSize(char *FontFile)
{
struct find_t Buffer;
_dos_findfirst(FontFile,_A_NORMAL,&Buffer);
return((size_t)Buffer.size);
}
/*------------------------------------------------------------------------*/

